﻿Imports System
Imports System.Runtime.InteropServices

Imports PROKDLL

Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim inp(80) As Double
        Dim s1 As New ProkCoil()
        Dim ris As Short
        Dim s As String

        'Some check on input data
        If Me.CALCTYPE.Text = "Condenser" And Convert.ToDouble(Me.TGOUT.Text) < Convert.ToDouble(Me.TGIN.Text) Then
            Me.TGIN.Text = "0"
            Me.TGOUT.Text = "20"
            If Me.LIQUIDTYPE.SelectedItem = "Water" Then
                MsgBox("Water is not a valid freon")
                Exit Sub
            End If
        End If

        If Me.CALCTYPE.Text = "Direct Expansion" And Convert.ToDouble(Me.TGOUT.Text) > Convert.ToDouble(Me.TGIN.Text) Then
            Me.TGIN.Text = "32"
            Me.HUMGIN.Text = "50"
            Me.TGOUT.Text = "18"
        End If


        For i = 0 To 79
            inp(i) = 0
        Next
        If Me.CoilTypeVal.SelectedItem = "1022" Then inp(5) = 2
        If Me.CoilTypeVal.SelectedItem = "1227" Then inp(5) = 88
        If Me.CoilTypeVal.SelectedItem = "1635" Then inp(5) = 89
        If Me.CoilTypeVal.SelectedItem = "1630" Then inp(5) = 90

        inp(13) = Convert.ToDouble(Me.TGIN.Text)
        inp(14) = Convert.ToDouble(Me.HUMGIN.Text)
        inp(15) = Convert.ToDouble(Me.AIRVOL.Text)
        inp(3) = Convert.ToDouble(Me.PAL.Text)
        inp(2) = Convert.ToDouble(Me.COILLEN.Text)
        inp(1) = Convert.ToDouble(Me.TUBES.Text)
        ' fin material
        inp(8) = 2 'See table "type of fins"
        ' fin thickness
        inp(9) = 0.15 'See table "type of fins"

        ' specify desired capacity or outside temperature
        inp(31) = Convert.ToDouble(Me.KWREQ.Text)
        If inp(31) = 0 Then inp(32) = Convert.ToDouble(Me.TGOUT.Text)
        ' number of rows
        If Convert.ToDouble(Me.NR.Text) > 0 Then
            inp(0) = Convert.ToDouble(Me.NR.Text)
            inp(31) = 0
            inp(32) = 0
        End If

        ' type of coil
        If Me.CALCTYPE.SelectedItem = "Liquid" Then inp(37) = 1
        If Me.CALCTYPE.SelectedItem = "Direct Expansion" Then inp(37) = 2
        If Me.CALCTYPE.SelectedItem = "Condenser" Then inp(37) = 3

        ' Liquid
        If inp(37) = 1 Then
            inp(16) = 1 ' Water
            inp(17) = Convert.ToDouble(Me.TLIN.Text)
            ' Set liquid volume OR liquid outside temperature
            inp(19) = Convert.ToDouble(Me.LIQVOL.Text)
            If inp(19) = 0 Then
                inp(18) = Convert.ToDouble(Me.TLOUT.Text)
            End If
            ' max liquid side pressure drop
            If inp(0) > 0 Then ' set number of circuits?
                ' specify number of row and circuits
                inp(4) = Convert.ToDouble(Me.NC.Text) ' number of circuits
                If inp(4) <= 0 Then
                    MsgBox("Please enter rows and circuits number for coil verification")
                    Exit Sub
                End If
            Else
                inp(20) = Convert.ToDouble(Me.DPMAX.Text)
            End If
            ' set ethilen glycol percentage
            inp(28) = Convert.ToDouble(Me.GLIC.Text)
            If inp(28) > 0 And inp(28) < 100 Then inp(27) = 1 Else Me.GLIC.Text = "0"

        End If


        ' Direct Expansion
        If inp(37) = 2 Then
            If Me.LIQUIDTYPE.SelectedItem = "Steam" Or Me.LIQUIDTYPE.SelectedItem = "Water" Then
                MsgBox("Steam or Water not allowed for ED coils")
                Exit Sub
            End If
            If Me.LIQUIDTYPE.SelectedItem = "R410a" Then inp(16) = 16
            If Me.LIQUIDTYPE.SelectedItem = "R404a" Then inp(16) = 13
            If Me.LIQUIDTYPE.SelectedItem = "R407c" Then inp(16) = 12
            If Me.LIQUIDTYPE.SelectedItem = "R134a" Then inp(16) = 4
            inp(24) = Convert.ToDouble(Me.CONDTEMP.Text)
            inp(22) = Convert.ToDouble(Me.EVAPTEMP.Text)
            If inp(22) >= inp(24) Then
                MsgBox("Wrong condensing or evaporating temperature")
                Exit Sub
            End If
            inp(26) = Convert.ToDouble(Me.SUBCOOL.Text)
            inp(25) = Convert.ToDouble(Me.SUPERHEAT.Text)

        End If


        'Condenser
        If inp(37) = 3 Then
            If Me.LIQUIDTYPE.SelectedItem = "R410a" Then inp(16) = 16
            If Me.LIQUIDTYPE.SelectedItem = "R404a" Then inp(16) = 13
            If Me.LIQUIDTYPE.SelectedItem = "R407c" Then inp(16) = 12
            If Me.LIQUIDTYPE.SelectedItem = "R134a" Then inp(16) = 4
            If Me.LIQUIDTYPE.SelectedItem = "Steam" Then inp(16) = 9
            inp(24) = Convert.ToDouble(Me.CONDTEMP.Text)
            inp(22) = Convert.ToDouble(Me.EVAPTEMP.Text)
            If inp(22) >= inp(24) Then
                MsgBox("Wrong condensing or evaporating temperature")
                Exit Sub
            End If
            inp(26) = Convert.ToDouble(Me.SUBCOOL.Text)
            inp(25) = Convert.ToDouble(Me.SUPERHEAT.Text)

        End If

        ' price factor
        inp(39) = Convert.ToDouble(Me.PriceFactor.Text)

        ' Calculation mode
        ' 1: std tolerance - 2 certified
        If Me.CALCMODE.SelectedItem = "Std Tolerance" Then inp(38) = 1
        If Me.CALCMODE.SelectedItem = "Certified" Then inp(38) = 2
        s = My.Computer.FileSystem.CurrentDirectory
        ChDir(s)
        ris = s1.ClCoil(inp, ".\INDITER\")

        If ris <> 0 Then
            MsgBox("Error number " & ris)
            Exit Sub
        End If
        Me.CoilType.Text = s1.CoilDesc
        Me.KWOUT.Text = s1.Capacity.ToString()
        Me.OUTAIR.Text = s1.AirOutTemperature.ToString() & "°C - " & s1.AirOutHumidity.ToString() & "%"
        Me.WEIGHT.Text = s1.CoilWeight.ToString()
        Me.DPAIR.Text = s1.AirPressureDrop.ToString()
        Me.DPLIQ.Text = s1.LiquidPressureDrop.ToString()
        If Me.CALCTYPE.SelectedItem = "Liquid" Then
            Me.LIQOUT.Text = s1.LiquidOutTemperature.ToString() & "°C - " & s1.LiquidVolume.ToString() & " dm3/h"
            Me.OUTL.Text = "Liquid outlet cond."
        Else
            Me.LIQOUT.Text = s1.LiquidWeight.ToString() & " kg/h"
            Me.OUTL.Text = "Freon weight"
        End If
        Me.VELAIR.Text = s1.AirVelocity.ToString()
        Me.VELLIQ.Text = s1.LiquidVelocity.ToString()
        Me.PriceLabel.Text = s1.vRis(27).ToString()
    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.CoilTypeVal.SelectedItem = "1227"
        Me.PAL.SelectedItem = "2,5"
        Me.CALCMODE.SelectedItem = "Certified"
        Me.TGIN.Text = "32"
        Me.HUMGIN.Text = "50"
        Me.TLIN.Text = "7"
        Me.TLOUT.Text = "12"
        Me.KWREQ.Text = "0"
        Me.DPMAX.Text = "30"
        Me.TGOUT.Text = "18"
        Me.COILLEN.Text = "1500"
        Me.TUBES.Text = "12"
        Me.AIRVOL.Text = "12500"
        Me.LIQVOL.Text = "0"
        Me.GLIC.Text = "0"
        Me.CALCTYPE.SelectedItem = "Liquid"
        Me.LIQUIDTYPE.SelectedItem = "Water"
        Me.CONDTEMP.Text = "40"
        Me.EVAPTEMP.Text = "0"
        Me.SUPERHEAT.Text = "0"
        Me.SUBCOOL.Text = "0"
        Me.NR.Text = "0"
        Me.NC.Text = "0"

    End Sub


    Private Sub LIQUIDTYPE_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LIQUIDTYPE.SelectedIndexChanged
        If Me.LIQUIDTYPE.SelectedItem = "Steam" Then
            Me.CONDTEMP.Text = 120 ' sample values
            Me.CALCTYPE.SelectedItem = "Condenser"
        End If
        If Me.LIQUIDTYPE.SelectedItem = "Water" And Me.CALCTYPE.SelectedItem <> "Liquid" Then
            Me.LIQUIDTYPE.Text = "R407c"
        End If
        If Me.CALCTYPE.Text = "Condenser" Then
            Me.CONDTEMP.Text = "30"
            Me.EVAPTEMP.Enabled = False
            Me.SUBCOOL.Text = "5"
            Me.SUPERHEAT.Text = "5"
            If Me.LIQUIDTYPE.SelectedItem = "Steam" Then
                Me.CONDTEMP.Text = 120 ' sample values
            End If
        End If

    End Sub
    Private Sub CALCTYPE_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CALCTYPE.SelectedIndexChanged
        If Me.CALCTYPE.Text = "Liquid" Then
            SetControls(True)
            Me.LIQUIDTYPE.SelectedItem = "Water"
        Else
            SetControls(False)
            If Me.CALCTYPE.Text = "Condenser" Then
                Me.CONDTEMP.Text = "40"
                Me.EVAPTEMP.Enabled = False
                Me.SUBCOOL.Text = "5"
                Me.SUPERHEAT.Text = "5"
                If Me.LIQUIDTYPE.SelectedItem = "Steam" Then
                    Me.CONDTEMP.Text = 120 ' sample values
                End If
            Else
                Me.CONDTEMP.Text = "25"
                Me.EVAPTEMP.Enabled = True
                Me.EVAPTEMP.Text = "-5"
                Me.SUBCOOL.Text = "5"
                Me.SUPERHEAT.Text = "5"
                Me.PAL.Text = "3,0"
            End If
        End If
    End Sub

    Private Sub SetControls(ByVal bSet As Boolean)

        Me.LIQUIDTYPE.Enabled = Not bSet
        Me.CONDTEMP.Enabled = Not bSet
        Me.EVAPTEMP.Enabled = Not bSet
        Me.SUBCOOL.Enabled = Not bSet
        Me.SUPERHEAT.Enabled = Not bSet
        Me.TLIN.Enabled = bSet
        Me.TLOUT.Enabled = bSet
        Me.GLIC.Enabled = bSet
        Me.DPMAX.Enabled = bSet
        Me.LIQVOL.Enabled = bSet

    End Sub

End Class


